package beans;

import entities.Cart;
import entities.OrderItem;
import entities.Product;
import java.util.HashSet;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;

@Named
@RequestScoped
public class Bb {
    private List<Cart> ls;

    @EJB
    UseGraph    db;
    
    @PostConstruct
    public void init(){
        try {
            if (db.counts() == 0) { // レコードがない
                createdb();    
            }
        } catch (Exception e) {// テーブルがない
            createdb();         
        }        
        ls = db.getAll();
    }
    // テーブルを作成する
    public void createdb() {
        Product p1 = new Product("pc1000");
        db.create(p1);
        Product p2 = new Product("pc2000");
        db.create(p2);
        Product p3 = new Product("pc3000");
        db.create(p3);

        Cart cart1 = new Cart("c1", null);
        HashSet<OrderItem> items1 = new HashSet<>();
        items1.add(new OrderItem(2, p1, cart1));
        items1.add(new OrderItem(3, p2, cart1));
        cart1.setItems(items1);
        db.create(cart1);
        //
        Cart cart2 = new Cart("c2", null);
        HashSet<OrderItem> items2 = new HashSet<>();
        items2.add(new OrderItem(5, p1, cart2));
        items2.add(new OrderItem(7, p2, cart2));
        items2.add(new OrderItem(8, p3, cart2));
        cart2.setItems(items2);
        db.create(cart2);
        //
        Cart cart3 = new Cart("c3", null);
        HashSet<OrderItem> items3 = new HashSet<>();
        items3.add(new OrderItem(2, p2, cart3));
        items3.add(new OrderItem(1, p3, cart3));
        cart3.setItems(items3);
        db.create(cart3);
    }
    public List<Cart> getLs() {
        return ls;
    }
    public void setLs(List<Cart> ls) {
        this.ls = ls;
    }
}
