package beans;

import entities.Cart;
import entities.Product;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityGraph;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceUtil;
import javax.persistence.TypedQuery;

@Stateless
public class UseGraph {
    @PersistenceContext
    private EntityManager em;

    public List<Cart> getAll() {
        TypedQuery<Cart> query = em.createQuery("SELECT c FROM Cart c", Cart.class);
        EntityGraph<?> graph = em.getEntityGraph("cart.graph");
        query.setHint("javax.persistence.loadgraph", graph);
        List<Cart> ls = query.getResultList();
        
        PersistenceUtil util = em.getEntityManagerFactory().getPersistenceUnitUtil();
        System.out.println(util.isLoaded(ls.get(0), "cartNumber"));
        System.out.println(util.isLoaded(ls.get(0), "items"));

        return ls;
    }
    public  void    create(Cart cart){
        em.persist(cart);
    }
    public  void    create(Product product){
        em.persist(product);
    }
    // 集計関数で全件数を求める
    public int counts(){
        Object o = (Object)em.createQuery("SELECT COUNT(c) FROM Cart c").getSingleResult();
        return  Integer.parseInt(String.valueOf(o));
    }
    /*
    　// findメソッドの時は次のようにする
     EntityGraph graph = this.em.getEntityGraph("graph.Order.items");
     Map hints = new HashMap();
     hints.put("javax.persistence.fetchgraph", graph);
     return this.em.find(Order.class, orderId, hints);
     */
}
